import random as rd
class Dog: #클래스 이름은 대문자로
    #클래스 변수 모든 객체들이 공유하는 값> 어떤 매소드에도 속해있지 않도록 만든다.
    dog_type='진돗개'#이
    
    #속성: 이름, 나이
    def __init__(self, age=3,name='흰둥이',fullness=5):
        #init은 무조건__개수동일하게 밑에 속성은_1,2개 상관없음
        #인자에 값을 주지않으면 초기값을 이용하도록
        #속성이름이_,__로 시작하면 이 속성은 private하므로
        #외부에서 접근 및 사용이 불가능한다.
        self.__age=age#class 안에 쓰여서 self를 써준다. 속성을 의미한다.
        self.__name=name
    #추가할 속성: 포만감(이상 10이하의 정수)
    #강아지가 배고프면(수치4이하) 밥을 주고, 배가 부르면 놀아주자> 매소드 play랑 eat 동작도 넣어야한다.이건 내부가 아닌 외부에서 동작
        self.__fullness=fullness

    #동작: 말한다(멍멍)
    def speak(self):
        print('멍멍')
    def hung():
        print('배고파요')
    def eat(self, food):
        if food>0:
            print('맛있어요.^^')
            self.__fullness+=food
            if self.__fullness>=10:
                self.__fullness=10
        else:#if food is lower than 0 means that is fake food
            print('give real food')
    def play(self):
        print('재밌어요.멍멍!')
    #private 한 속성 값을 알아낼 수 있는 통로:getter()를 만들자!
    #외부에서 속성값이 궁금할 때  볼 수 있게 만듦-물론 보여주고 싶지 않으면 안 만들면 된다.
    #get_속성명
    def get__fullness(self):
        return self.__fullness#내부에서 __속성을 함부로 접근하면 안되니까 밖에서 호출할 수 있도록 새로 만들어주자> 근데 클래스 내부니까 self.붙여 줘야한다.
    #private한 속성 값을 변경할 수 있는 창구: setter()를 만들자!. 속성의 필요에 따라
    #외부에서 속성을 변경할 수 있도록 만듦
    #set_속성명
    def set_name(self, name): #애는 self말고 매개변수 바꿀 변수 값 한개더 받음
        #유효성 체크
        #너무 길거나 이상한 ㅇㄹㄴ얾 이런 이름을 짓지 못하게 만듦
        if len(name)<5:
            self.__name=name
            
        elif 'shit' in name:
            self.__name='개똥이'
            
        else:
            self.__name='개똥이'
    def __add__(self,other):#강아지 나이 합 반환
        return self.__age+other.__age
    #<
    def __gt__(self, other):
        #return self.__age> other.__age
        if self.__age>other.__age:
            return True
        else:
            return False
    def __eq__(self, other):
        return self.__name==other.__name and self.__age==other.__age
    def __repr__(self):
        return f'이름:{self.__name} , 나이: {self._age}세'
    
    def __str__(self):
        return f'이름:{self.__name}, 나이:{self.__age}세' #객체의 이름과 나이가 나와야한다.

    #속성은 외부에서 함부로 접근, 변경 불가능하게 하자!
    #속성은 private하게 두자> 속성 정의시__로 시작하면 private를 의미한다.
def dog_test1():
    #Dog(1,'개똥') 이건 가능하다 Dog('개똥',1) 순서가 바뀌면 바뀐 값으로 나이와 이름으로 들어가므로 인자의 이름을 같이 불러야한다.
    d=Dog(age=5,name='개똥')
    print('강아지 타입:',d.dog_type)
    #if d.__fullness<=4: #there is no() , that is not func, that is 속성 but we must not access the __private속성> how: private 한 속성 알수있게 만들어는 줘야함
        #먹이준다= 강아지에게 먹으라고 요청한다
    if d.get__fullness()<=4: #d의 포만감이니까 앞에 강아지d.의 매소드를 의미한다
        d.eat(4)
    else:
        d.play()
    d.speak()
    #_age인 경우는 외부에 건들면 안되는 코드 파이썬에서 강제하지 않아서 변경이 됨 >쨌든 사용하지 말자! 
    '''
    d.age=-100 외부에서 속서에 접근하지 않도록한다.
    이런방법 이용하지 않도록한다.
    print(d.age)#강아지 d의 나이 출력
    print(d.name)#강아지 d의 이름 출력
    '''
    d.set_name(name='쭈니')
    print(d)
    #1세의 뽀삐
    d2=Dog(age=3,name='뽀삐')
    print('강아지 타입:',d2.dog_type)
    #보통 객체에 소속된것이 아니라 클래스에 소속된 것이므로 틀래스명을 붙인다.
    #클래스 변수는 클래스명.변수명으로 접근!
    print('강아지 타입:',Dog.dog_type)
    d2.speak()
    print(d) #->이름:*** ,나이:***
    print(d.__str__())
    print(d2)
    #__age __name 설명
    #강아지 속성을 1개 더 추가해보자

    print(d+d2)#두 강아지의 합
    print(d.__add__(d2))#위의 코드와 동일한 의미>>이거 +-*/만 문제로 낼 듯, 부등호.. 이거 기말에 +정의하는 함수 작성하고 문제 나왔다고 함
    print(Dog.__add__(d,d2))#self의 의미는 위 라인의 add앞의 d를 의미하는 것 실제로 사용은 안한다.

    print(d>d2)#나이비교 #__gt__
    print(d<d2)#나이비교 #__lt__

    print(d==d2) #__eq__(): 두 강아지의 이름과 나이가 같은 경우 True, 아니라면 False를 반환하도록 작성

    d3=Dog(age=3,name='뽀삐')
    print(d2==d3)

    #객체의 속성(key) 값을 딕셔너리로 제공한다.
    print(d2.__dict__)


def dog_test2():
    dog_list=[Dog(name='흰둥이'),Dog(1)]
    print(dog_list) 
    #[<__main__.Dog object at 0x000002873EF455D0>, <__main__.Dog object at 0x000002873EF453D0>]
    
    #string구현 안했을떄 저렇게 나오는데 이번에는 해놨긴함 그래도 위의 것처럼 나옴>repr함수 정의
    
    #객체들을 정렬하고 싶을때 따로 함수를 만들지 않고 sorted를 이용해서 할 수 있다.
    print(sorted(dog_list))#sorted를 구현할려며 < 나 >를 구현시켜야한다. 대신 뭐가 큰건지 기준을 알려줘야함 ><구현하면서 .이때는 나이로 했으니까 나이로 나옴
    print(dog_list[0])
    #이름:흰둥이, 나이:3세 index로 출력하면 잘 된다.,이건 str메소드 구현 str없어도 repr있으면 index랑 list다 구현해준다. 
    

class Person:
    def __init__(self, name, age, height):
        self._name=name
        self._age=age
        self._height=height
    def __str__(self):
        return f'이름:{self._name} , 나이:{self._age}, 키:{self._height}'
    
    def go_to_school (self):
        if self._age<8:
            print('학교에 다니지 않습니다.')
        elif self._age<20:
            print('학교에 다닙니다.')
        else:
            print('학교를 졸업했습니다.')
    def __gt__(self,other):
        return self._height>other._height
    def __sub__(self, other):
        return self._height-other._height
    
    def play(self):
        if self._age>= 8 and self._height>=100:
            print('놀이기구 탑승 가능')
        else:
            print('놀이기구 탑승 불가능')
    
def test7():
    hong=Person(name='홍길동',age=15, height=165)
    go=Person(name='고길동',age=40, height=175)
    duli=Person(name='둘리',age=6, height=100)
    print(hong)
    print(go)
    print(duli)
    hong.go_to_school()
    go.go_to_school()
    duli.go_to_school()
    duli.play()
    print(hong>go)
    print(hong-duli)
    
    
test7()

    